<%-- $Id: edit_user.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"	
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="java.util.Date"
	import="java.util.List"	
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.USER;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	User user = null;
	
	List<ExtendedProperty> extendedProperties = ExtendedProperties.getProperties("UserData");

	final QuotaType total = QuotaType.getById(dc, SystemItems.getId(QuotaType.TOTAL));
	Quota currentQuota = null;
	Group currentQuotaGroup = null;
	Directory homeDirectory = null;

	// Query to retrieve group membership
	ItemQuery<Group> groupQuery = null;
	// Query to retrieve role membership
	ItemQuery<Role> roleQuery = null;

	if (itemId == 0)
	{
		title = "Create user";
		cc.removeObject("item");
		if (cc.getPropertyFilter("quota.name") != null)
		{
			currentQuota = Base.getFirstMatching(dc, Quota.getQuery(), "name", cc.getPropertyFilter("quota.name"));
		}
		else
		{
			currentQuota = Quota.getById(dc, SystemItems.getId(Quota.DEFAULT));
		}	
		if (cc.getPropertyFilter("quotaGroup.name") != null)
		{
			currentQuotaGroup = Base.getFirstMatching(dc, Group.getQuery(), "name", cc.getPropertyFilter("quotaGroup.name"));
		}
		
		groupQuery = Group.getQuery();
		groupQuery.restrict(
			Restrictions.eq(
				Hql.property("default"), 
				Expressions.parameter("isDefault", true, Type.BOOLEAN)
			)
		);
		groupQuery.order(Orders.asc(Hql.property("name")));
		roleQuery = Role.getQuery();
		roleQuery.restrict(
			Restrictions.eq(
				Hql.property("default"), 
				Expressions.parameter("isDefault", true, Type.BOOLEAN)
			)
		);
		roleQuery.order(Orders.asc(Hql.property("name")));
		
	}
	else
	{
		user = User.getById(dc, itemId);
		cc.setObject("item", user);
		title = "Edit user -- " + HTML.encodeTags(user.getName());

		try
		{
			currentQuota = user.getQuota();
		}
		catch (PermissionDeniedException ex)
		{}
		try
		{
			currentQuotaGroup = user.getQuotaGroup();
		}
		catch (PermissionDeniedException ex)
		{}
		try
		{
			homeDirectory = user.getHomeDirectory();
		}
		catch (PermissionDeniedException ex)
		{}

		groupQuery = user.getGroups();
		groupQuery.include(Include.ALL);
		groupQuery.order(Orders.asc(Hql.property("name")));
		roleQuery = user.getRoles();
		roleQuery.include(Include.ALL);
		roleQuery.order(Orders.asc(Hql.property("name")));
	}
	if (user != null && !user.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	
	final boolean readQuota = sc.hasPermission(Permission.READ, Item.QUOTA);
	final boolean useQuota = sc.hasPermission(Permission.USE, Item.QUOTA);
	final boolean createDirectories = sc.hasPermission(Permission.CREATE, Item.DIRECTORY);
	final boolean readDirectories = sc.hasPermission(Permission.READ, Item.DIRECTORY);
	final boolean readGroups = sc.hasPermission(Permission.READ, Item.GROUP);
	final boolean useGroups = sc.hasPermission(Permission.USE, Item.GROUP);
	final boolean writeGroups = sc.hasPermission(Permission.WRITE, Item.GROUP);
	final boolean writeRoles = sc.hasPermission(Permission.WRITE, Item.ROLE);
	final boolean writeMembership = writeGroups && writeRoles;
	
	// Query to retrieve quota
	final ItemQuery<Quota> quotaQuery = Quota.getQuery();
	quotaQuery.include(Include.ALL);
	quotaQuery.order(Orders.asc(Hql.property("name")));
	quotaQuery.setCacheResult(true);

	// Query to retrieve quota groups
	final ItemQuery<Group> quotaGroupQuery = Group.getQuery();
	quotaGroupQuery.include(Include.ALL);
	quotaGroupQuery.order(Orders.asc(Hql.property("name")));
	quotaGroupQuery.restrict(Restrictions.neq(Hql.property("quota"), null));
	quotaGroupQuery.setCacheResult(true);

	// Query to retrieve home directories
	final ItemQuery<Directory> directoryQuery = Directory.getQuery();
	directoryQuery.include(Include.ALL);
	directoryQuery.order(Orders.asc(Hql.property("name")));
	directoryQuery.restrict(
		Restrictions.eq(
			Hql.property("parent"),
			Expressions.integer(SystemItems.getId(Directory.HOME))
		)
	);
	directoryQuery.setCacheResult(true);

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "User" tab
		function validateUser()
		{
			var frm = document.forms['user'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert('You must enter a name for the user.');
				frm.name.focus();
				return false;
			}
			else if (Main.trimString(frm.login.value) == '')
			{
				alert('You must enter a login for the user.');
				frm.login.focus();
				return false;
			}
			else if (frm.new_password.value != frm.retype_password.value)
			{
				frm.retype_password.focus();
				alert('The two passwords do not match!');
				return false;
			} 
			<%
			if (itemId == 0)
			{
				%>
				else if (Main.trimString(frm.new_password.value) == '')
				{
					alert('You must enter a password for the user.');
					frm.new_password.focus();
					return false;
				}
				<%
			}
			%>			
			return true;
		}
		
		// Validate the "Extended properties" tab
		function validateExtendedProperties()
		{
			var frm = document.forms['user'];
			var field;
			<%
			if (extendedProperties != null)
			{
				for (ExtendedProperty ep : extendedProperties)
				{
					Type type = ep.getType();
					String name = ep.getName();
					%>
					field = frm['<%=name%>'];
					<%
					if (type == Type.DATE)
					{
						%>
						if (!Dates.isDate(field.value))
						{
							alert("'"+field.value+"' is not a valid date for '<%=HTML.javaScriptEncode(ep.getTitle())%>'");
							field.focus();
							return false;
						}
						<%
					}
					if (!ep.isNullable())
					{
						if (type == Type.BOOLEAN)
						{
							%>
							if (Forms.getCheckedRadio(field) == null)
							{
								alert("You must select a value for '<%=HTML.javaScriptEncode(ep.getTitle())%>'");
								field.focus();
								return false;
							}
							<%
						}
						else
						{
							%>
							if (Main.trimString(field.value) == '')
							{
								alert("You must enter a value for '<%=HTML.javaScriptEncode(ep.getTitle())%>'.");
								field.focus();
								return false;
							}
							<%
						}
					}
				}
			}
			%>
			return true;
		}
		
		// Validate the "Contact information" tab
		function validateContact()
		{
			return true;
		}
		
		// Validate the "Membership" tab
		function validateMembership()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['user'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.addRoles.value = Link.getActionIds(1, 'R').join(',');
				frm.removeRoles.value = Link.getActionIds(-1, 'R').join(',');
				frm.addGroups.value = Link.getActionIds(1, 'G').join(',');
				frm.removeGroups.value = Link.getActionIds(-1, 'G').join(',');
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (user == null)
			{
				%>
				var frm = document.forms['user'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initMembership();
		}
		function initMembership()
		{
			var members = document.forms['user'].membership;
			Link.addNewSection(members, new Section('G', 'Groups'));
			<%
			if (groupQuery != null)
			{
				ItemResultList<Group> groups = groupQuery.list(dc);
				for (Group group : groups)
				{
					%>
					Link.addNewItem(members, new Item('G', <%=group.getId()%>, '<%=HTML.javaScriptEncode(group.getName())%>'));
					<%
				}
			}
			%>
			Link.addNewSection(members, new Section('R', 'Roles'));
			<%
			if (roleQuery != null)
			{
				ItemResultList<Role> roles = roleQuery.list(dc);
				for (Role role : roles)
				{
					%>
					Link.addNewItem(members, new Item('R', <%=role.getId()%>, '<%=HTML.javaScriptEncode(role.getName())%>'));
					<%
				}
			}
			%>
		}
		function addRolesOnClick()
		{
			var roles = Link.getListIds(document.forms['user'].membership, 'R');
			var url = '../roles/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addRoleCallback';
			url += '&exclude='+roles.join(',');
			Main.openPopup(url, 'AddRoles', 1000, 700);
		}
		function addRoleCallback(roleId, name)
		{
			var item = Link.getItem('R', roleId);
			if (!item) item = new Item('R', roleId, name);
			Link.addItem(document.forms['user'].membership, item);
		}
		function addGroupsOnClick()
		{
			var groups = Link.getListIds(document.forms['user'].membership, 'G');
			var url = '../groups/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addGroupCallback';
			url += '&exclude='+groups.join(',');
			Main.openPopup(url, 'AddGroups', 1000, 700);
		}
		function addGroupCallback(groupId, name)
		{
			var item = Link.getItem('G', groupId);
			if (!item) item = new Item('G', groupId, name);
			Link.addItem(document.forms['user'].membership, item);
		}
		function removeOnClick()
		{
			Link.removeSelected(document.forms['user'].membership);
		}
	
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="user" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*300)+"px;"%>" 
			position="bottom" remember="<%=user != null%>">
		<t:tab id="info" title="User" validate="validateUser()" helpid="user.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td colspan="2"><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(user == null ? Values.getString(cc.getPropertyValue("name"), "New user") : user.getName())%>" 
					size="40" maxlength="<%=User.MAX_NAME_LENGTH%>"></td>
			</tr>

			<tr>
				<td class="prompt">Login</td>
				<td colspan="2"><input <%=requiredClazz%> type="text" name="login" 
					value="<%=HTML.encodeTags(user == null ? cc.getPropertyValue("login") : user.getLogin())%>" 
					size="40" maxlength="<%=User.MAX_LOGIN_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">External ID</td>
				<td colspan="2"><input <%=clazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(user == null ? cc.getPropertyValue("externalId") : user.getExternalId())%>" 
					size="40" maxlength="<%=User.MAX_EXTERNAL_ID_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">New password</td>
				<td colspan="2"><input <%=itemId == 0 ? requiredClazz : clazz%> type="password" name="new_password" value="" size="30" maxlength="30"></td>
			</tr>
			<tr>
				<td class="prompt">Retype password</td>
				<td colspan="2"><input <%=itemId == 0 ? requiredClazz : clazz%> type="password" name="retype_password" value="" size="30" maxlength="30"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Quota</td>
				<td colspan="2">
					<select name="quota_id" <%=!useQuota ? "disabled readonly class=\"disabled\"" : "class=\"required\""%>>
					<%
					if (!readQuota)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					ItemResultList<Quota> quotas = quotaQuery.list(dc);
					for (Quota quota : quotas)
					{
						boolean current = quota.equals(currentQuota);
						if (!current && quota.isRemoved()) continue;
						int id = quota.getId();
						long totalBytes = quota.getQuotaValue(total, Location.PRIMARY);
						String fTotal = totalBytes == Quota.UNLIMITED ? "unlimited" : Values.formatBytes(totalBytes);
						%>
						<option 
							value="<%=current && user != null ? -id : id%>" 
							<%=current ? "selected" : ""%>
							><%=HTML.encodeTags(quota.getName())%> (<%=fTotal%> total)
						<%
					}
					%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Quota group</td>
				<td colspan="2">
					<select name="quotagroup_id" <%=!useGroups ? "disabled readonly class=\"disabled\"" : ""%>>
					<%
					if (!readGroups)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">- none -
						<%
						ItemResultList<Group> quotaGroups = quotaGroupQuery.list(dc);
						for (Group quotaGroup : quotaGroups)
						{
							boolean current = quotaGroup.equals(currentQuotaGroup);
							if (!current && quotaGroup.isRemoved()) continue;
							int id = quotaGroup.getId();
							Quota quota = quotaGroup.getQuota();
							long totalBytes = quota.getQuotaValue(total, Location.PRIMARY);
							String fTotal = totalBytes == Quota.UNLIMITED ? "unlimited" : Values.formatBytes(totalBytes);
							%>
							<option 
								value="<%=current && user != null ? -id : id %>"
								<%=current ? "selected" : ""%>
								><%=HTML.encodeTags(quotaGroup.getName())%> (<%=fTotal%> total)
							<%
						}
					}
					%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Home directory</td>
				<td colspan="2">
					<select name="homedirectory_id" <%=!readDirectories ? "disabled readonly class=\"disabled\"" : ""%>>
					<%
					if (!readDirectories)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">- none -
						<%
						if (createDirectories && user == null)
						{
							%>
							<option value="new">- create new (empty) -
							<option value="template" selected>- create new from template -
							<%
						}
						ItemResultList<Directory> directories = directoryQuery.list(dc);
						for (Directory d : directories)
						{
							int id = d.getId();
							boolean current = d.equals(homeDirectory);
							if (!current && d.isRemoved()) continue;
							%>
							<option 
								value="<%=current && user != null ? -id : id%>" 
								<%=current ? "selected" : ""%>
								><%=HTML.encodeTags(d.getName())%>
							<%
						}
					}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Expiration date</td>
				<td>
					<input <%=clazz%> type="text" name="expiration_date" 
						value="<%=HTML.encodeTags(dateFormatter.format(
								user == null ? (Date)cc.getPropertyObject("expirationDate") : user.getExpirationDate())
							)%>"
						size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
				</td>
				<td>
				<base:button 
					onclick="<%="Dates.selectDate('Expiration date', 'user', 'expiration_date', null, '"+jsDateFormat + "')"%>" 
					image="calendar.png"
					title="Calendar&hellip;" 
					tooltip="Select a date from a calendar"
				/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Multi-user account</td>
				<td colspan="2"><input type="checkbox" name="multiuser_account" value="1" 
					<%=(user != null && user.isMultiuserAccount()) || 
						(user == null && Values.getBoolean(cc.getPropertyValue("multiuserAccount"))) ? "checked" : ""%>></td>
			</tr>
			<tr>
				<td class="prompt">Disabled</td>
				<td colspan="2"><input type="checkbox" name="disabled" value="1" 
					<%=(user != null && user.isDisabled()) || 
						(user == null && Values.getBoolean(cc.getPropertyValue("disabled"))) ? "checked" : ""%>></td>
			</tr>
			
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="contact" title="Contact information" 
			tooltip="Email, adress, organisation, etc." validate="validateContact()" helpid="user.edit.contact">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Email</td>
				<td><input <%=clazz%> type="text" name="email" 
					value="<%=HTML.encodeTags(user == null ? cc.getPropertyValue("email") : user.getEmail())%>" 
					size="40" maxlength="<%=User.MAX_EMAIL_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Organisation</td>
				<td><input <%=clazz%> type="text" name="organisation" 
					value="<%=HTML.encodeTags(user == null ? cc.getPropertyValue("organisation") : user.getOrganisation())%>" 
					size="40" maxlength="<%=User.MAX_ORGANISATION_LENGTH%>"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Address</td>
				<td>
					<textarea <%=clazz%> rows="4" cols="40" name="address" 
						wrap="off"><%=HTML.encodeTags(user == null ? cc.getPropertyValue("address") : user.getAddress())%></textarea>
					<a href="javascript:Main.zoom('Address', 'user', 'address')" title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			<tr>
				<td class="prompt">Phone</td>
				<td><input <%=clazz%> type="text" name="phone" 
					value="<%=HTML.encodeTags(user == null ? cc.getPropertyValue("phone") : user.getPhone())%>" 
					size="40" maxlength="<%=User.MAX_PHONE_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Fax</td>
				<td><input <%=clazz%> type="text" name="fax" 
					value="<%=HTML.encodeTags(user == null ? cc.getPropertyValue("fax") : user.getFax())%>" 
					size="40" maxlength="<%=User.MAX_FAX_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Url</td>
				<td><input <%=clazz%> type="text" name="url" 
					value="<%=HTML.encodeTags(user == null ? cc.getPropertyValue("url") : user.getUrl())%>" 
					size="40" maxlength="<%=User.MAX_URL_LENGTH%>"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" 
						wrap="virtual"><%=HTML.encodeTags(user == null ? cc.getPropertyValue("description") : user.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'user', 'description')" title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
		</t:tab>
		<%
		if (extendedProperties != null)
		{
			%>
			<t:tab id="extended" title="Additional info" 
				validate="validateExtendedProperties()" helpid="user.edit.additional">
				<table class="form" cellspacing="0">
					<%
						for (ExtendedProperty ep : ExtendedProperties.getProperties("UserData"))
						{
							String name = ep.getName();
							Type type = ep.getType();
							boolean required = !ep.isNullable();
							Object value = user == null ? cc.getPropertyValue(name) : user.getExtended(name);
							String theClazz = required ? requiredClazz : clazz;
							%>
							<tr valign="top">
								<td class="prompt"><%=HTML.encodeTags(ep.getTitle())%></td>
								<td>
								<%
								if (type == Type.INT || type == Type.LONG)
								{
									%>
									<input <%=theClazz%> type="text" name="<%=name%>" 
										value="<%=value == null ? "" : value%>"
										size="20" maxlength="20" onkeypress="return Numbers.integerOnly(event)"
										>
									<%
								}
								else if (type == Type.FLOAT || type == Type.DOUBLE)
								{
									%>
									<input <%=theClazz%> type="text" name="<%=name%>"
										value="<%=value == null ? "" : value%>"
										size="20" maxlength="20" onkeypress="return Numbers.numberOnly(event)"
										>
									<%
								}
								else if (type == Type.STRING)
								{
									%>
									<input <%=theClazz%> type="text" name="<%=name%>"
										value="<%=HTML.encodeTags((String)value)%>"
										size="40" maxlength="<%=ep.getLength()%>"
										>
									<%
								}
								else if (type == Type.TEXT)
								{
									%>
									<textarea <%=theClazz%> name="<%=name%>" rows="6" cols="40"
										><%=HTML.encodeTags((String)value)%></textarea>
									<a href="javascript:Main.zoom(
										'<%=HTML.javaScriptEncode(ep.getTitle())%>', 
										'reporter', '<%=name%>')" 
										title="Edit in larger window"><base:icon image="zoom.gif" /></a>
									<%
								}
								else if (type == Type.BOOLEAN)
								{
									Boolean b = (Boolean)value;
									if (!required)
									{
										%>
										<input type="radio" name="<%=name%>" value=""
											<%=b == null ? "checked" : ""%> 
											><i>- not specified -</i><br>
										<%
									}
									%>
									<input type="radio" name="<%=name%>" value="true" 
										<%=b != null && b == true ? "checked" : ""%>
										>true<br>
									<input type="radio" name="<%=name%>" value="false" 
										<%=b != null && b == false ? "checked" : ""%>
										>false
									<%
								}
								else if (type == Type.DATE)
								{
									%>
									<table>
									<tr>
									<td>
										<input <%=theClazz%> type="text" name="<%=name%>" 
											value="<%=dateFormatter.format((Date)value)%>"
											size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>"
											>
									</td>
									<td>
										<base:button 
											onclick="<%="Dates.selectDate('"+HTML.javaScriptEncode(ep.getTitle())+"', 'reporter', '"+name+"', null, '"+jsDateFormat +"')"%>" 
											image="calendar.png"
											title="Calendar&hellip;" 
											tooltip="Select a date from a calendar" 
										/>
									</td>
									</tr>
									</table>
									<%
								}
								%>
								</td>
							</tr>
							<%
						}
					%>
				</table>
			</t:tab>
		<%
		}
		%>		
		<t:tab id="members" title="Membership" 	tooltip="Manage group and role membership" 
			validate="validateMembership()" helpid="user.edit.membership">
			<table >
			<tr valign="top">
			<td>
				<b>Member in</b><br>
				<select name="membership" size="15" multiple <%=!writeMembership ? "disabled readonly class=\"disabled\"" : ""%> style="width: 15em;">
				</select>
				<input type="hidden" name="removeGroups" value="">
				<input type="hidden" name="addGroups" value="">
				<input type="hidden" name="removeRoles" value="">
				<input type="hidden" name="addRoles" value="">
			</td>
			<td>
				<br>
				<table width="150">
				<tr><td><base:button 
					onclick="addGroupsOnClick()" 
					title="Add&nbsp;groups&hellip;"  
					tooltip="Add groups to this user"
					disabled="<%=!writeMembership %>" 
				/></td></tr>
				<tr><td><base:button 
					onclick="addRolesOnClick()" 
					title="Add&nbsp;roles&hellip;"  
					tooltip="Add roles to this user"
					disabled="<%=!writeMembership %>" 
				/></td></tr>
				<tr><td><base:button 
					onclick="removeOnClick()" 
					title="Remove" 
					tooltip="Remove the user from the selected items"
					disabled="<%=!writeMembership%>" 
				/></td></tr>
				</table>
			</td>
			</tr>
			</table>

		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
