<%-- $Id: calendar.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	A window for selecting a date interactively from a calendar

	@param title The title of the input field on the parent form
	@param form The name of the form where the input field is located
	@param input The name of the input field containing the current date value
	@param callback A javascript function to call to set the date in the
		opener's form (optional)

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
	String title = request.getParameter("title");
	String form = request.getParameter("form");
	String input = request.getParameter("input");
	String callback = request.getParameter("callback");
	String format = Values.getString(request.getParameter("format"), "yyyy-MM-dd");
%>
<base:page type="popup" title="<%=title%>">
<base:head styles="calendar.css">
	<script language="JavaScript">
	function init()
	{
		var date = getDate();
		var frm = document.forms['calendar'];
		Forms.selectListOption(frm.month, date.getMonth());
		frm.year.value = Dates.getFourDigitYear(date.getFullYear());
		displayMonth(date.getFullYear(), date.getMonth(), date);
	}
	
	function getDate()
	{
		var frm = window.opener.document.forms['<%=form%>'];
		var dateString = frm['<%=input%>'].value;
		var date = Dates.parseString(dateString, '<%=HTML.javaScriptEncode(format)%>');
		if (date == null) date = new Date();
		return date;
	}
	
	function setDate(theDate)
	{
		var formattedDate = Dates.formatDate(theDate, '<%=HTML.javaScriptEncode(format)%>');
		<%
		if (callback == null)
		{
			%>
			var frm = window.opener.document.forms['<%=form%>'];
			frm['<%=input%>'].value = formattedDate;
			<%
		}
		else
		{
			%>
			window.opener.<%=callback%>('<%=form%>', '<%=input%>', formattedDate);
			<%
		}
		%>
		window.close();
	}
	
	function setToday()
	{
		setDate(new Date());
	}
	
	function displayMonth(year, month, current)
	{
		var date = Dates.newDate(year, month, 1);
		var today = new Date();
		var firstDay = date.getDay();
		firstDay = firstDay == 0 ? 6 : firstDay - 1;
		var dayOfMonth = 1-firstDay;
		var daysInMonth = Dates.daysInMonth(year, month+1);
		for (var week = 1; week <= 6; week++) // >
		{
			for (var day = 0; day <= 6; day++) // >
			{
				var cell = document.getElementById('w'+week+'d'+day);
				if (dayOfMonth < 1 || dayOfMonth > daysInMonth)
				{
					cell.firstChild.nodeValue = ' ';
					cell.theDate = '';
				}
				else
				{
					cell.firstChild.nodeValue = dayOfMonth;
					cell.theDate = Dates.newDate(year, month, dayOfMonth);
				}
				if (year == today.getFullYear() && month == today.getMonth() && dayOfMonth == today.getDate())
				{
					Main.addClass(cell, 'today');
				}
				else
				{
					Main.removeClass(cell, 'today');
				}
				if (year == current.getFullYear() && month == current.getMonth() && dayOfMonth == current.getDate())
				{
					Main.addClass(cell, 'current');
				}
				else
				{
					Main.removeClass(cell, 'current');
				}
				dayOfMonth++;
			}
		}
	}
	
	function changeMonth()
	{
		var frm = document.forms['calendar'];
		if (frm.year.value.length != 4) 
		{
			Main.showInline('invalidyear');
			return;
		}
		else
		{
			Main.hide('invalidyear');
		}
		var month = Number(frm.month[frm.month.selectedIndex].value);
		var year = Number(frm.year.value);
		displayMonth(year, month, getDate());
	}
	
	</script>
</base:head>
<base:body onload="init()">
	<form name="calendar" onsubmit="changeMonth(); return false;">
	<h3 class="docked"><%=title%><base:help helpid="calendar.selectday" /></h3>
	<div class="boxed">

		<table width="100%" border="0" cellspacing=0 cellpadding=0 style="margin-bottom: 4px;" >
		<tr>
		<td>
		<select name="month" onchange="changeMonth();">
			<option value="0">January
			<option value="1">February
			<option value="2">March
			<option value="3">April
			<option value="4">May
			<option value="5">June
			<option value="6">July
			<option value="7">August
			<option value="8">September
			<option value="9">October
			<option value="10">November
			<option value="11">December
		</select>
		</td>
		<td style="text-align: right;">
			<span id="invalidyear" class="error" style="display: none;">Year must have 4 digits!</span>
			<input type="text" class="text" name="year" size="4" maxlength="4" 
				onkeypress="return Numbers.integerOnly(event);"
				onkeyup="changeMonth()">
		</td>
		</tr>
		</table>

		<table width="100%" border=0 cellspacing=0 cellpadding=0 class="calendar">
		<tr>
			
			<td class="day">Mon</td>
			<td class="day">Tue</td>
			<td class="day">Wed</td>
			<td class="day">Thu</td>
			<td class="day">Fri</td>
			<td class="day">Sat</td>
			<td class="day">Sun</td>
		</tr>
		<%
		for (int week = 1; week < 7; ++week)
		{
			%>
			<tr id="w<%=week%>">
			<%
			for (int day = 0; day < 7; ++day)
			{
				%>
				<td id="w<%=week%>d<%=day%>" 
					class="date <%=day==6 ? "sunday" : ""%>" 
					onmouseover="if (this.theDate) Main.addClass(this, 'hover')" 
					onmouseout="Main.removeClass(this, 'hover');"
					onclick="if (this.theDate) setDate(this.theDate)"><%=day%></td>
				<%
			}
			%>
			</tr>
			<%
		}
		%>
		</table>
	</div>
	</form>
	<table align="center">
	<tr>
		<td><base:button image="today.png" onclick="setToday()" title="Today" /></td>
		<td><base:button onclick="window.close()" title="Cancel" /></td>
	</tr>
	</table>
</base:body>
</base:page>
