/* $Id: parameters.js 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	JavaScript functions for managing plugins and configurations.

	@author Nicklas
	@version 2.0
*/
var Parameters = new ParametersClass();

function ParametersClass()
{
	this.allParameters = new Array();

	this.addParameterValuesToForm = function(frm)
	{
		for (var i = 0; i < this.allParameters.length; i++)
		{
			var pp = this.allParameters[i];
			for (var j = 0; j < pp.values.length; j++)
			{
				Forms.createHidden(frm, 'parameter:'+pp.name, pp.values[j]);
			}
		}
	}
}

function Parameter(name, label, multiplicity, enumeration, required, values)
{
	this.name = name;
	this.label = label;
	this.valueType = 0;
	this.multiplicity = multiplicity;
	this.required = required;
	this.enumeration = enumeration;
	this.values = values;
	this.modified = false;

	Parameters.allParameters[Parameters.allParameters.length] = this;
	Parameters.allParameters['ID'+name] = this;
	
	this.addValue = function(value)
	{
		if (this.multiplicity > 0 && this.values.length >= this.multiplicity)
		{
			alert('Max '+this.multiplicity+' values allowed');
			return false;
		}
		this.values[values.length] = value;
		this.modified = true;
		return true;
	}
	
	this.removeValue = function(index)
	{
		if (this.values.length > index)
		{
			this.values.splice(index, 1);
			this.modified = true;
			return true;
		}
		return false;
	}
	
	this.updateValue = function(index, value)
	{
		if (value != this.values[index])
		{
			this.values[index] = value;
			this.modified = true;
			return true;
		}
		return false;
	}

	this.clearValues = function()
	{
		if (this.values.length > 0)
		{
			this.values = new Array();
			this.modified = true;
			return true;
		}
		return false;
	}
	
	this.setValues = function(values)
	{
		this.values = values;
		this.modified = true;
		return true;
	}

}
