<%-- $Id: view_eventtype.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.PlateEventType"
	import="net.sf.basedb.core.ProtocolType"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.data.RawData"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.PLATEEVENTTYPE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	final PlateEventType eventType = PlateEventType.getById(dc, itemId);
	final PlateType plateType = eventType.getPlateType();
	final int plateTypeId = plateType.getId();

	ProtocolType currentProtocolType = null;
	boolean readCurrentProtocolType = true;
	try
	{
		currentProtocolType = eventType.getProtocolType();
	}
	catch (PermissionDeniedException ex)
	{
		readCurrentProtocolType = false;
	}
	
	final boolean writePermission = eventType.hasPermission(Permission.WRITE);
	final boolean deletePermission = eventType.hasPermission(Permission.DELETE);
	%>

	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="toolbar.css,table.css,headertabcontrol.css,path.css">
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function deleteItem()
		{
			if (confirm('This can\'t be undone. Continue?'))
			{
				location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&platetype_id=<%=plateTypeId%>&item_id=<%=itemId%>');
			}
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&platetype_id=<%=plateTypeId%>&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Plate types" href="<%="../index.jsp?ID="+ID%>" />
			<p:pathelement 
				title="<%=HTML.encodeTags(plateType.getName())%>" 
				href="<%="index.jsp?ID="+ID+"&platetype_id="+plateTypeId%>" />
			<p:pathelement title="<%=HTML.encodeTags(eventType.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="properties">
		<t:tab id="properties" title="Properties">

		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this event type" : "You do not have permission to edit this event type"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				tooltip="<%=deletePermission ? "Delete this event type" : "You do not have permission to event this plate type"%>" 
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
				<tbl:button
					image="help.gif"
					onclick="<%="Main.openHelp('" + ID +"', 'plateeventtype.view.properties')"%>"
					title="Help&hellip;"
					tooltip="Get help about this page"
				/>
			</tbl:toolbar>
			
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(eventType)%></i></div>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(eventType.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Ordinal</td>
				<td><%=eventType.getOrdinal()%></td>
			</tr>
			<tr>
				<td class="prompt">Protocol type</td>
				<td><base:propertyvalue item="<%=eventType%>" property="protocolType" /></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(eventType.getDescription())%></td>
			</tr>
			</table>
		</div>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
